/**
 * 
 */
package eu.etaxonomy.taxeditor.forms;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import eu.etaxonomy.cdm.common.CdmUtils;

/**
 * @author nho
 *
 */
public class TextActionComposite extends AbstractFormComposite {

	private Label label;
	private Text text;
	private Button button;

	/**
	 * @param parent
	 * @param style
	 */
	protected TextActionComposite(Composite parent, String labelString, String initialText, int style) {
		super(parent, null, style);
		
		this.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
		GridLayout layout = (GridLayout) this.getLayout();
		layout.numColumns = 2;
		
		label = toolkit.createLabel(this, labelString, SWT.WRAP);
		GridData labelData = new GridData(SWT.FILL, SWT.TOP, true, false);
		labelData.horizontalSpan = 2;
		label.setLayoutData(labelData);
		
		text = toolkit.createText(this, "", SWT.BORDER | SWT.MULTI | SWT.WRAP);
		text.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
		
		setText(CdmUtils.Nz(initialText));
		
		button = toolkit.createButton(this, "Show", SWT.PUSH);
		addPropertyChangeListener(this);
	}

	/**
	 * @param text the text to set
	 */
	public void setText(String string) {
		text.setText(CdmUtils.Nz(string));
	}

	/**
	 * @return the text
	 */
	public String getText() {
		return text.getText();
	}

	public void addSelectionListener(SelectionListener listener){
		button.addSelectionListener(listener);
	}

	public void removeSelectionListener(SelectionListener listener){
		button.removeSelectionListener(listener);
	}
}
