/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import java.util.Set;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
import eu.etaxonomy.cdm.model.description.DescriptionElementBase;

/**
 * 
 * @author n.hoffmann
 * @created Nov 17, 2009
 * @version 1.0
 */
public class DescriptionElementSourceSection extends AbstractEntitySetSection<DescriptionElementBase> implements IPropertyChangeListener{


	/**
	 * 
	 * @param parent
	 * @param entity
	 * @param listener
	 * @param style
	 */
	public DescriptionElementSourceSection(Composite parent, DescriptionElementBase entity, IPropertyChangeListener listener, int style){
		super(parent, entity, "Citations", listener, style);
	}

	/*
	 * (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetSection#createDynamicContents()
	 */
	public void createDynamicContents() {
		
		Set<DescriptionElementSource> sources = null;
		if(getEntity() != null){
			sources = getEntity().getSources();
		}
		
		if(sources == null || sources.size() == 0){
			toolkit.createLabel(container, "No citations yet.");
		}else{
			for(DescriptionElementSource source : sources){
				new DescriptionElementSourceComposite(container, source, new RemoveListener(source), this, SWT.NULL);
			}
		}
	}
	
	/**
	 * 
	 */
	private class RemoveListener extends SelectionAdapter{
		private DescriptionElementSource source;
		
		public RemoveListener(DescriptionElementSource source){
			this.source = source;
		}
		
		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
		 */
		@Override
		public void widgetSelected(SelectionEvent e) {
			getEntity().removeSource(source);
			internalUpdateSection(true);
		}
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractEntitySetSection#getAddAction()
	 */
	@Override
	protected IAction getAddAction() {
		Action addCitation = new Action("add", Action.AS_PUSH_BUTTON){
			/* (non-Javadoc)
			 * @see org.eclipse.jface.action.Action#run()
			 */
			@Override
			public void run() {
				getEntity().addSource(DescriptionElementSource.NewInstance());
				if(! getSection().isExpanded())
					getSection().setExpanded(true);
				internalUpdateSection(true);
			}
		};
		addCitation.setToolTipText("Create a new citation");
		return addCitation;
	}
}
