/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.Extension;
import eu.etaxonomy.taxeditor.forms.MultilineTextWithLabel;
import eu.etaxonomy.taxeditor.forms.termcombos.ExtensionTypeComboComposite;

/**
 * 
 * @author n.hoffmann
 * @created Nov 17, 2009
 * @version 1.0
 */
public class ExtensionComposite extends AbstractEntitySetElementComposite<Extension> {

	/**
	 * @param parent
	 * @param element
	 * @param removeListener
	 * @param propertyChangelistener
	 * @param style
	 */
	public ExtensionComposite(Composite parent, Extension element,
			SelectionListener removeListener,
			IPropertyChangeListener propertyChangelistener, int style) {
		super(parent, element, removeListener, propertyChangelistener, style);
	}

	private ExtensionTypeComboComposite extensionTypeCombo;
	private MultilineTextWithLabel extensionValue;
	

	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractFormComposite#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent event) {
		element.setType(extensionTypeCombo.getSelection());
		element.setValue(extensionValue.getText());
		
		super.propertyChange(event);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#createControls(org.eclipse.swt.widgets.Composite, int)
	 */
	@Override
	public void createControls(Composite parent, int style) {
		extensionTypeCombo = new ExtensionTypeComboComposite(parent, "Extension Type", null, this, style);
		extensionValue = toolkit.createMultilineTextWithLabel(parent, "Extension Content", this, 100, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#setElement(eu.etaxonomy.cdm.model.common.VersionableEntity)
	 */
	@Override
	public void setElement(Extension element) {
		this.element = element;
		extensionTypeCombo.setSelection(element.getType());
		extensionValue.setText(element.getValue());	
	}

}
