/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.selectioncomposites;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.name.TaxonNameBase;
import eu.etaxonomy.taxeditor.dialogs.filteredSelection.FilteredNameSelectionDialog;

/**
 * @author nho
 *
 */
public class NameSelectionComposite extends AbstractSelectionComposite<TaxonNameBase> {

	/**
	 * @param parent
	 * @param labelString
	 * @param selection
	 * @param style
	 */
	public NameSelectionComposite(Composite parent, String labelString,
			TaxonNameBase selection, IPropertyChangeListener listener, int style) {
		super(parent, labelString, selection, listener, style);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	@Override
	public void widgetSelected(SelectionEvent e) {
		super.widgetSelected(e);
		selection = FilteredNameSelectionDialog.selectName(getShell(), selection);
		updateText();
		
		// Notify listeners. Otherwise changes will be lost. (solves issue similar to ticket #1333)
		firePropertyChangeEvent(null);
	}

}
