/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.termcombos;

import java.util.List;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.Language;
import eu.etaxonomy.taxeditor.preference.PreferencesUtil;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 *
 */
public class LanguageComboComposite extends AbstractTermComboComposite<Language> {

	private static final int VISIBLE_ITEMS = 20;

	/**
	 * 
	 * @param parent
	 * @param labelString
	 * @param selection
	 * @param style
	 */
	public LanguageComboComposite(Composite parent, String labelString, Language selection, IPropertyChangeListener listener, int style) {
		super(parent, labelString, selection, listener, VISIBLE_ITEMS, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractTermComboComposite#preferredTerms()
	 */
	@Override
	protected List<Language> preferredTerms() {
		return PreferencesUtil.getPreferredLanguages();
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.termcombos.AbstractTermComboComposite#getLabel(eu.etaxonomy.cdm.model.common.DefinedTermBase)
	 */
	@Override
	protected String getLabel(Language term) {
		return term.getDescription(CdmStore.getDefaultLanguage());
	}
}
