/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.propertysheet;

import org.eclipse.ui.views.properties.PropertySheetEntry;

import eu.etaxonomy.cdm.model.taxon.Taxon;
import eu.etaxonomy.taxeditor.editor.name.TaxonNameEditor;

/**
 * Redraws editor / freetext area when a value in the property sheet changes.
 * </p>
 * @author p.ciardelli
 * @created 16.05.2008
 * @version 1.0
 */
public class EditorPropertySheetEntry extends PropertySheetEntry {
	
	private TaxonNameEditor taxonEditor;
	
	public EditorPropertySheetEntry(Taxon taxon, final TaxonNameEditor taxonNameEditor) {
		super();
		
		this.taxonEditor = taxonNameEditor;
	}
	
    protected void valueChanged(PropertySheetEntry child) {
    	
    	super.valueChanged(child);
    	
    	// If this is the top level of the property sheet, redraw the freetext area
    	if (getParent() == null) {
    		taxonEditor.postOperation(null);
    	}
    }
}