/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.name;

import eu.etaxonomy.cdm.model.name.ZoologicalName;
import eu.etaxonomy.cdm.model.reference.ReferenceBase;
import eu.etaxonomy.taxeditor.propertysheet.reference.ReferenceSearchDescriptor;

/**
 * Property source for ZoologicalName entries.
 *  
 * @author p.ciardelli
 * @created 21.05.2008
 * @version 1.0
 */
public class ZoologicalNamePropertySource extends NonViralNamePropertySource {

	private ZoologicalName zoologicalName;
	
	public static final String P_NOMENCLATURAL_REF = "Original Reference";
		
	public ZoologicalNamePropertySource(ZoologicalName name) {
		super(name);
		this.zoologicalName = name;
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.propertysheet.name.NonViralNamePropertySource#addDescriptor(java.lang.String)
	 */
	@Override
	protected void addDescriptor(String id) {
		// Nomenclatural reference
		if (id.equals(P_ID_NOMENCLATURAL_REF)) {
//			descriptors.addElement(
//					new PropertyDescriptor(P_ID_NOMENCLATURAL_REF,P_NOMENCLATURAL_REF));
//			
			descriptors.addElement(new ReferenceSearchDescriptor(P_ID_NOMENCLATURAL_REF,P_NOMENCLATURAL_REF, (ReferenceBase) name.getNomenclaturalReference()) {
				protected void saveReference(ReferenceBase reference) {
					setPropertyValue(P_ID_NOMENCLATURAL_REF, reference);
				}
			});
			
			return;
		}
		
		
		super.addDescriptor(id);
	}
}