// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.propertysheet.tabbed;

import org.apache.log4j.Logger;
import org.eclipse.core.runtime.Assert;
import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.StructuredSelection;

import eu.etaxonomy.taxeditor.editor.GroupedComposite;

/**
 * @author n.hoffmann
 * @created 05.06.2009
 * @version 1.0
 */
public class TabbedPropertyPageLabelProvider extends LabelProvider implements
		ILabelProvider {
	private static final Logger logger = Logger
			.getLogger(TabbedPropertyPageLabelProvider.class);

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.LabelProvider#getText(java.lang.Object)
	 */
	@Override
	public String getText(Object element) {
		Assert.isTrue(element instanceof StructuredSelection, "Given element is not a StructuredSelection");
		StructuredSelection selection = (StructuredSelection) element;
		
		Assert.isTrue(selection.getFirstElement() instanceof GroupedComposite, "Selection is not a grouped composite");
		GroupedComposite groupedComposite = (GroupedComposite) selection.getFirstElement();
		
		return super.getText(groupedComposite.getData());
	}
}
