// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.navigation.navigator;

import org.apache.log4j.Logger;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import eu.etaxonomy.cdm.model.taxon.TaxonNode;
import eu.etaxonomy.cdm.model.taxon.TaxonomicTree;

/**
 * @author p.ciardelli
 * @created 02.06.2009
 * @version 1.0
 */
public class TaxonNodeContentProvider implements ITreeContentProvider {
	private static final Logger logger = Logger
			.getLogger(TaxonNodeContentProvider.class);

	private static final Object[] NO_CHILDREN = new Object[0];
	
	public Object[] getChildren(Object parentElement) {
		Object[] children = null;		
		if (parentElement instanceof TaxonNode) {
			children = ((TaxonNode) parentElement).getChildNodes().toArray();
		} else if (parentElement instanceof TaxonomicTree) {
			children = ((TaxonomicTree) parentElement).getRootNodes().toArray();
		}
		return children != null ? children : NO_CHILDREN;
	}

	public Object getParent(Object element) {
		if(element instanceof TaxonNode){
			return ((TaxonNode) element).getParent();
		}		
		return null;
	}

	public boolean hasChildren(Object element) {
		
		boolean length = this.getChildren(element).length > 0;
		
		return length;
	}

	public Object[] getElements(Object inputElement) {
		return this.getChildren(inputElement);
	}

	public void dispose() {
	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}
}
