// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.dialogs.filteredSelection;

import java.util.UUID;

import org.apache.log4j.Logger;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import eu.etaxonomy.cdm.model.agent.Person;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 * @created Sep 24, 2009
 * @version 1.0
 */
public class FilteredPersonSelectionDialog extends
		AbstractFilteredCdmResourceSelectionDialog<Person> {
	private static final Logger logger = Logger
	.getLogger(FilteredPersonSelectionDialog.class);
	
	public static Person selectPerson(Shell shell, Person person){
		FilteredPersonSelectionDialog dialog = new FilteredPersonSelectionDialog(shell, 
				"Choose a person", false, FilteredPersonSelectionDialog.class.getCanonicalName(), person);
		return getSelectionFromDialog(dialog); 
	}
	
	/**
	 * @param shell
	 * @param title
	 * @param multi
	 * @param settings
	 * @param cdmObject
	 */
	protected FilteredPersonSelectionDialog(Shell shell, String title,
			boolean multi, String settings, Person cdmObject) {
		super(shell, title, multi, settings, cdmObject);
	}



	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.filteredSelection.AbstractFilteredCdmResourceSelectionDialog#getPersistentObject(java.util.UUID)
	 */
	@Override
	protected Person getPersistentObject(UUID uuid) {
		return (Person) CdmStore.getAgentService().load(uuid);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.dialogs.filteredSelection.AbstractFilteredCdmResourceSelectionDialog#initModel()
	 */
	@Override
	protected void initModel() {
		model = CdmStore.getAgentService().getPersonUuidAndNomenclaturalTitle();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.dialogs.FilteredItemsSelectionDialog#createExtendedContentArea(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected Control createExtendedContentArea(Composite parent) {
		return null;
	}
}
