// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.preference.menu;

import org.apache.log4j.Logger;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import eu.etaxonomy.cdm.model.common.ExtensionType;
import eu.etaxonomy.cdm.model.common.VocabularyEnum;
import eu.etaxonomy.taxeditor.preference.wizards.VocabularyTermWizard;
import eu.etaxonomy.taxeditor.store.StoreUtil;
import eu.etaxonomy.taxeditor.store.VocabularyStore;

/**
 * @author n.hoffmann
 * @created Aug 28, 2009
 * @version 1.0
 */
public class ExtensionTypeMenuPreferences extends AbstractMenuPreferences<ExtensionType> {
	private static final Logger logger = Logger
			.getLogger(ExtensionTypeMenuPreferences.class);
	
	/**
	 * 
	 */
	public ExtensionTypeMenuPreferences() {
		super(VocabularyStore.getExtensionTypes(),
				"Extension Type Preferences" , 
				"Choose which extension types to display",
				true);
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.preference.AbstractMenuPreferences#addEditButtonListeners()
	 * 
	 * TODO refactor into superclass
	 */
	@Override
	protected void addNewButtonListeners() {
		newButton.addSelectionListener(new SelectionAdapter(){
			/* (non-Javadoc)
			 * @see org.eclipse.swt.events.SelectionAdapter#widgetSelected(org.eclipse.swt.events.SelectionEvent)
			 */
			@Override
			public void widgetSelected(SelectionEvent e) {
				super.widgetSelected(e);
				VocabularyTermWizard<ExtensionType> wizard = new VocabularyTermWizard<ExtensionType>(VocabularyEnum.ExtensionType); 
				
				WizardDialog dialog = new WizardDialog(StoreUtil.getShell(), wizard);
			    dialog.open();
			    
			    tableViewer.setInput(VocabularyStore.getExtensionTypes());
			}
		});
	}
}
